package com.example.mob_dev_portfolio.data.source.local

import androidx.lifecycle.LiveData
import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import com.example.mob_dev_portfolio.data.Product

@Dao
interface ProductsDao {
	@Insert(onConflict = OnConflictStrategy.REPLACE)
	 fun insert(product: Product)

	@Insert(onConflict = OnConflictStrategy.REPLACE)
	 fun insertListOfProducts(products: List<Product>)

	@Query("SELECT * FROM products")
	 fun getAllProducts(): List<Product>

	@Query("SELECT * FROM products")
	fun observeProducts(): LiveData<List<Product>>

	@Query("SELECT * FROM products WHERE owner = :ownerId")
	fun observeProductsByOwner(ownerId: String): LiveData<List<Product>>

	@Query("SELECT * FROM products WHERE productId = :proId")
	 fun getProductById(proId: String): Product?

	@Query("SELECT * FROM products WHERE owner = :ownerId")
	 fun getProductsByOwnerId(ownerId: String): List<Product>

	@Query("DELETE FROM products WHERE productId = :proId")
	 fun deleteProductById(proId: String): Int

	@Query("DELETE FROM products")
	 fun deleteAllProducts()
}