package com.example.mob_dev_portfolio.data.source.local

import androidx.room.*
import com.example.mob_dev_portfolio.data.UserData

@Dao
interface UserDao {
	@Insert(onConflict = OnConflictStrategy.REPLACE)
	 fun insert(uData: UserData)

	@Query("SELECT * FROM users WHERE userId = :userId")
	 fun getById(userId: String): UserData?

	@Query("SELECT * FROM users WHERE mobile = :mobile")
	 fun getByMobile(mobile: String): UserData?

	@Update(entity = UserData::class)
	 fun updateUser(obj: UserData)

	@Query("DELETE FROM users")
	 fun clear()
}